%{
/* 
**  Parser for Cobol Compiler
**
 */
#define YYDEBUG 1


#include <stdio.h>
#include <stdlib.h>
#include <string.h> 

#include <stdarg.h>
#if defined(SunOS)
va_list __builtin_va_alist;
#endif

#include <ctype.h>

#include "htcoboly.h"
#include "htcoblib.h"
#include "htglobals.h"

extern int screen_io_enable,scr_line,scr_column;
extern int decimal_comma;
extern char currency_symbol;
extern int errcnt;
extern int lineno;
extern FILE *lexin;
extern FILE *o_src;
extern struct sym *curr_paragr,*curr_section;
extern struct sym *curr_field;
extern short curr_call_mode;
extern struct sym *pgm_id;
extern unsigned stack_offset;   /* offset das variaveis na pilha */
extern unsigned global_offset;  /* offset das variaveis globais (DATA) */
extern int paragr_num;
extern int loc_label;
extern char picture[];
extern int picix,piccnt,decimals,sign,v_flag;
extern int at_linkage,stack_plus;
extern char *toktext;
extern int yylex(void);
extern struct index_to_table_list *index2table;

struct sym *curr_file;
struct sym *alloc_filler( void );
int curr_division=0;
extern char *include_filename;
extern char *yytext;

unsigned long lbend, lbstart;
unsigned int perform_after_sw;

/* struct math_var *vl1, *vl2; */

%}

%union {
    struct sym *sval;       /* symbol */
    int ival;               /* int */
    struct coord_pair pval; /* lin,col */
    struct lit *lval;       /* literal */
    unsigned long dval;     /* label definition, compacted */
    char *str;
    struct vref *rval;      /* variable reference (with subscripts) */
    struct refmod *rmval;	/* variable with RefMod specifier */
    struct string_from *sfval; /* variable list in string statement */
    struct unstring_delimited *udval;
    struct unstring_destinations *udstval;
    struct tallying_list *tlval;
    struct tallying_for_list *tfval;
    struct replacing_list *repval;
    struct replacing_by_list *rbval;
    struct inspect_before_after *baval;
    struct scr_info *sival;
    struct perf_info *pfval;
    struct perform_info *pfvals;
    struct sortfile_node *snval;
    struct selsubject *ssbjval;
    struct list *lstval;	/* generic container list */
    struct math_var *mval;	/* math variables container list */
    struct math_ose *mose;	/* math ON SIZE ERROR variables container */
}

%nonassoc LOW_PREC

%token <str>  IDSTRING
%token <sval> STRING,VARIABLE,VARCOND,SUBSCVAR
%token <sval> LABELSTR,CMD_LINE,ENVIRONMENT_VARIABLES
%token <ival> CHAR,MULTIPLIER
%token <ival> USAGENUM,ZERONUM,DIVISNUM,CONNECTIVE,CONDITIONAL
%token <ival> COMMENTING,DIRECTION,READ,WRITE,INPUT_OUTPUT
%token <lval> NLITERAL,CLITERAL
%token <ival> PORTNUM,OPENMD,DATE_TIME

%left   '+','-'
%left   '*','/'

%left  OR
%left  AND
%right NOT

%token BEFORE,AFTER,SCREEN,REVERSEVIDEO,NUMBERTOK,PLUS,MINUS,SEPARATE
%token FOREGROUNDCOLOR,BACKGROUNDCOLOR,UNDERLINE,HIGHLIGHT,LOWLIGHT
%token RIGHT,AUTO,REQUIRED,FULL,JUST,BLINK,SECURE,BELL,COLUMN,SYNC
%token INITIALTOK,FIRSTTOK,ALL,LEADING,OF,IN,COPY,BY,STRINGCMD,UNSTRING
%token START,DELETE,DATE_TIME,PROGRAM,GLOBAL,EXTERNAL,SIZE,DELIMITED
%token GIVING,ERASE,INSPECT,TALLYING,REPLACING,ONTOK,POINTER,OVERFLOWTK
%token DELIMITER,COUNT,LEFT,TRAILING,CHARACTER
%token ADD,SUBTRACT,MULTIPLY,DIVIDE,ROUNDED,REMAINDER,ERRORTOK,SIZE
%token FD,SD,REDEFINES,PIC,FILLER,OCCURS,TIMES
%token PROGRAM_ID,DIVISION,CONFIGURATION,SPECIAL_NAMES
%token FILE_CONTROL,I_O_CONTROL
%token SAME,AREA,ESCAPE
%token ECHOT,FROM,UPDATE
%token WORKING_STORAGE,LINKAGE,DECIMAL_POINT,COMMA
%token FILEN,USAGE,BLANK
%token SIGN,VALUE,MOVE,LABEL,DARK
%token RECORD,OMITTED,STANDARD,RECORDS,BLOCK
%token CONTAINS,CHARACTERS,COMPUTE,GO,STOP,RUN
%token ACCEPT,PERFORM,VARYING,UNTIL,EXIT
%token IF,ELSE,NEXT,SENTENCE,LINE,PAGETOK
%token OPEN,CLOSE,REWRITE
%token ADVANCING,INTO,AT,END,NEGATIVE,POSITIVE,SPACES,NOT
%token CALL,USING,INVALID,CONTENT
%token SELECT,ASSIGN,DISPLAY,UPON,CONSOLE,STD_OUTPUT,STD_ERROR
%token ORGANIZATION,ACCESS,MODE,KEY,STATUS,ALTERNATE
%token SEQUENTIAL,INDEXED,DYNAMIC,RANDOM,RELATIVE
%token SECTION,SORT,DUPLICATES,WITH
%token QUOTES,LOWVALUES,HIGHVALUES,LISTSEP,NOTEXCEP
%token SET,UP,DOWN
%token TRACE,READY,RESET
%token SEARCH,WHEN,TEST
%token END_ADD,END_CALL,END_COMPUTE,END_DELETE,END_DIVIDE,END_EVALUATE
%token END_IF,END_MULTIPLY,END_PERFORM,END_READ,END_REWRITE,END_SEARCH
%token END_START,END_STRINGCMD,END_SUBTRACT,END_UNSTRING,END_WRITE
%token THEN,EVALUATE,OTHER,ALSO,CONTINUE,CURRENCY,REFERENCE,INITIALIZE
%token NUMERIC,ALPHABETICTOK,ALPHABETICLOWER,ALPHABETICUPPER
%token RETURNING,TOKTRUE,TOKFALSE,ANY,SUBSCVAR,FUNCTION
%token REPORT,TOKRD,TOKCODE,CONTROL,LIMIT,FINAL
%token HEADING,FOOTING,TOKLAST,DETAIL,GROUP,INDICATE,TOKSUM
%token TOKPOSITION,FILE_ID,DEPENDING,TYPETOK,TOKSOURCE
%token INITIATE,GENERATE,TERMINATE

%right OF
%nonassoc EOS

%type <ival> organization_options,access_options,open_mode
%type <ival> integer,cond_op,conditional,before_after
%type <ival> IF,ELSE,usage,write_options,opt_next,echo_options
%type <ival> division_id,pic_char,opt_program,using_options,using_parameters
%type <dval> if_part 
%type <sval> anystring,name,gname,opt_def_name,def_name,procedure_section
%type <sval> field_description,label,filename,noallname,paragraph,assign_clause
%type <lval> literal,gliteral,without_all_literal,all_literal,special_literal
%type <lval> nliteral
%type <sval> accept_part,sort_keys,opt_perform_thru
%type <sval> read_into,write_from
%type <sval> variable,def_var,perform_range,perform_options,name_or_lit,delimited_by
%type <sval> subs_var,subscripted_variable
%type <sval> string_with_pointer
%type <ival> opt_all,with_duplicates,opt_with_test
%type <rval> subscript,subscripts
%type <sfval> string_from_list,string_from
%type <sval> opt_unstring_count,opt_unstring_delim,unstring_tallying
%type <udval> unstring_delimited_vars,unstring_delimited
%type <udstval> unstring_destinations,unstring_dest_var
%type <baval> inspect_before_after
%type <tlval> tallying_list, tallying_clause
%type <tfval> tallying_for_list
%type <ival> replacing_kind,opt_plus_minus
%type <repval> replacing_list, replacing_clause
%type <rbval> replacing_by_list
%type <sval> var_or_nliteral,read_key
%type <sival> screen_clauses
%type <ival> screen_attrib,sign_clause,opt_separate
%type <sval> variable_indexed,search_opt_varying,opt_key_is
%type <dval> search,search_all,search_when,search_all_when,search_opt_at_end
%type <ival> parm_type,sign_condition,class_condition
%type <sval> intrinsic_parm_list,intrinsic_parm
%type <sval> parm_list,parameter,expr,opt_expr,condition
%type <sval> cond_name,implied_op_condition
%type <pfval> perform_after
%type <pfvals> opt_perform_after
%type <ival> ext_cond,extended_cond_op
%type <sval> returning_options
%type <snval> sort_file_list,sort_input,sort_output
%type <ival> opt_not,selection_subject,selection_object,when_case
%type <ssbjval> selection_subject_set
%type <sval> screen_to_name, opt_depending_on
%type <lstval> label_list
%type <lval> signed_nliteral
%type <ival> sentence_or_nothing,when_case_list
%type <ival> opt_rounded
%type <mval> var_list_name, var_list_gname
%type <mose> opt_on_size_error

%%
%{
void yyunion( YYSTYPE *to, YYSTYPE *from );
%}
/************   Parser for Cobol Source  **************/

program:
    division_id DIVISION EOS {
        if ($1!=IDENTIFICATION)
            hterror(1,12,"IDENTIFICATION DIVISION expected");
        curr_division = CDIV_IDENT;
        }
        identification_division { }
    division_id DIVISION EOS {
        if ($7!=ENVIRONMENT)
            yyerror("ENVIRONMENT DIVISION expected");
        { define_special_fields(); }
        curr_division = CDIV_ENVIR;
        }
        environment_division
    division_id DIVISION EOS {
        if ($12!=DATA)
            yyerror("DATA DIVISION expected");
        curr_division = CDIV_DATA;
        }
        data_division       { data_trail(); }
    division_id DIVISION { curr_division = CDIV_PROC; }
        using_parameters EOS {
            if ($18!=PROCEDURE)
                yyerror("PROCEDURE DIVISION expected");
            proc_header($21);
        }
        procedure_division  {
            /* close procedure_division sections & paragraphs */
            close_section(); /* this also closes paragraph */
            proc_trail($21); }
    ;
division_id:
    DIVISNUM
    ;
identification_division:
    PROGRAM_ID "." IDSTRING EOS { 
        curr_division = CDIV_COMMENT;
        pgm_header($3); }
    ;
environment_division:
    opt_configuration
    opt_input_output
    ;
opt_configuration:
    CONFIGURATION SECTION EOS configuration_section 
    | copy_stat
    | /*nothing */
    ;
opt_input_output:
    INPUT_OUTPUT SECTION EOS input_output_section
    | /*nothing */
    ;
configuration_section:
    configuration_section configuration_option  { }
    | /* nothing */                 { }
    ;
configuration_option:
    COMMENTING "." STRING EOS { $3->type = ';'; }
    | SPECIAL_NAMES EOS special_names_sentences_or_copy
    | error { yyerror("invalid format in CONFIGURATION SECTION"); }
    ;
special_names_sentences_or_copy:
    special_names_sentences
    | copy_stat
    | /*nothing*/
    ;
special_names_sentences:
    currency_details_opt
    decimal_point_details_opt
    EOS
    ;
currency_details_opt:
    currency_details
    | /* nothing */
    ;
currency_details:
    CURRENCY opt_sign CONNECTIVE CLITERAL {
                if($3!=IS)
                    yyerror("IS expected");
                currency_symbol = $<lval>4->name[0];
		}
    ;
opt_sign:
    SIGN
    | /* nothing */
    ;
decimal_point_details_opt:
    decimal_point_details
    | /* nothing */
    ;
decimal_point_details:
    DECIMAL_POINT CONNECTIVE COMMA {
                if($2!=IS)
                    yyerror("IS expected");
                decimal_comma=1; }
    ;
input_output_section:
    input_output_section i_o_option { }
    | /* nothing */     { }
    ;
i_o_option:
    FILE_CONTROL EOS file_control 
    | I_O_CONTROL EOS io_control 
    | copy_stat
    | error { yyerror("I-O SECTION format wrong"); }
    ;
file_control:
    file_control file_select 
    | /* nothing */
    ;

/* SELECT def_name ASSIGN opt_to filename {*/
/*    SELECT def_name ASSIGN opt_to opt_portnum opt_filename {*/
file_select:
    SELECT def_name ASSIGN opt_to assign_clause {
            $2->type='F';   /* mark as file variable */
            curr_file=$2;
            $2->pic=0;  /* suppose not indexed yet */
            $2->defined=1;
            $2->parent=NULL; /* assume no STATUS yet 
                            this is "file status" var in files */
            $2->organization = 2;
            $2->access_mode = 1;
            $2->times=-1;
            $2->filenamevar=$5; /* this is the variable w/filename */
            $2->alternate=NULL; /* reset alternate key list */
         }
      select_clauses EOS {
	  		if ((curr_file->organization==ORG_INDEXED) &&
				!(curr_file->ix_desc)) {
				yyerror("indexed file must have a record key");
				YYABORT;
			}
	  	}
    ;
assign_clause: PORTNUM { $$=NULL; }
    | filename { $$=$1; }
    | PORTNUM filename { $$=$2; }
    | error  { yyerror("Invalid ASSIGN clause in SELECT statement"); }
    ;
select_clauses:
    select_clauses select_clause 
    | /* nothing */
    ;
select_clause:
    ORGANIZATION opt_is organization_options
                { curr_file->organization=$3; }
    | ACCESS opt_mode opt_is access_options
                { curr_file->access_mode=$4; }
    | FILEN STATUS opt_is STRING
                { curr_file->parent=$4; }
    | RECORD KEY opt_is STRING { curr_file->ix_desc=$4; }
    | RELATIVE KEY opt_is STRING { curr_file->ix_desc=$4; }
    | ALTERNATE RECORD KEY opt_is STRING 
        with_duplicates { add_alternate_key($5,$6); } 
    | error         { yyerror("invalid clause in select"); }
    ;
with_duplicates:
    WITH DUPLICATES     { $$=1; }
    | /* nothing */     { $$=0; }
    ;
opt_is:
    CONNECTIVE  { if ($1!=IS) yyerror("IS expected"); }
    | /* nothing */
    ;
opt_mode:
    MODE
    | /* nothing */
    ;
organization_options:
    INDEXED     { $$=1; }
    | SEQUENTIAL    { $$=2; }
    | RELATIVE  { $$=3; }
    | LINE SEQUENTIAL { $$=4; }
    | anystring { yyerror("invalid option, %s",
            $1->name); }
    ;
access_options:
    SEQUENTIAL  { $$=1; }
    | DYNAMIC   { $$=2; }
    | RANDOM    { $$=3; }
    | anystring { yyerror("invalid access option, %s",
            $1->name); }
    ;
io_control:
    io_control io_ctrl
    | /* nothing */
    ;
io_ctrl:
    SAME AREA CONNECTIVE name_list EOS {
            if ($3!=FOR) yyerror("FOR expected");
        }
    ;
name_list:
    variable    
    | name_list variable
    | error { yyerror("variable expected"); } 
    ;
data_division:
    opt_file_section
    opt_working_storage
    opt_linkage_section
    opt_screen_section
    opt_record_section
	;
opt_record_section:
	REPORT SECTION EOS 
	report_section
	| /* nothing */
;
opt_screen_section:
    SCREEN SECTION EOS  { 
					screen_io_enable++; 
					curr_field=NULL;
					scr_line = scr_column = 1;
			}
    screen_section      { close_fields(); }
    | /* nothing */
    ;
opt_file_section:
    FILEN SECTION EOS  { curr_field=NULL; }
    file_section   { close_fields();  }
    | /* nothing */
    ;
opt_working_storage:
    WORKING_STORAGE SECTION EOS     { curr_field=NULL; }
    working_storage_section         { close_fields(); }
    | /* nothing */
    ;
opt_linkage_section:
    LINKAGE SECTION EOS     { at_linkage=1; curr_field=NULL; }
    linkage_section         { close_fields(); at_linkage=0; }
    | /* nothing */
    ;
report_section:
	report_section TOKRD { /*curr_division = CDIV_FD;*/ } 
		STRING { $4->type='W'; curr_division = CDIV_PROC; } 
		report_controls { curr_division = CDIV_DATA; }
		report_description
	| /* nothing */
	;
report_controls:
	/* nothing */
	| report_controls CONTROL opt_is_are opt_final report_break_list
	| report_controls PAGETOK opt_limit_is integer opt_lines
	| report_controls 
		HEADING opt_is integer
		opt_first_detail opt_last_detail
		opt_footing EOS
	;
opt_lines:
	/* nothing */
	| LINE
	;
opt_limit_is:
	/* nothing */
	| LIMIT opt_is
	;
opt_footing:
	/* nothing */
	| FOOTING opt_is integer
	;
opt_last_detail:
	/* nothing */
	| TOKLAST DETAIL opt_is integer
	;
opt_first_detail:
	/* nothing */
	| FIRSTTOK DETAIL opt_is integer
	;
opt_final:
	/* nothing */
	| FINAL

report_break_list:
	/* nothing */
	| report_break_list name { $2->defined=1; }
	;
report_description:
	report_item
	| report_description report_item
	;
report_item:
	integer opt_def_name { 
			if ($2 == NULL) {
				$2 = alloc_filler();
				picix=piccnt=v_flag=decimals=0;
				picture[picix]=0;
			}
			define_field($1,$2); }
	report_clauses EOS 
		{ update_report_field($2); curr_division = CDIV_DATA; }
	| copy_stat
	;
report_clauses:
	/* nothing */
	| report_clauses TYPETOK opt_is report_type 
		report_position { curr_division = CDIV_PROC; } 
		opt_report_name
	| report_clauses report_line 
	| report_clauses opt_report_column
		opt_report_pic { curr_division = CDIV_PROC; } 
		report_value
	;
opt_report_name:
	name
	| FINAL
	| /* NOTHING */
	;
report_value:
	/* nothing */
	| VALUE opt_is gname
	| TOKSOURCE opt_is gname
	| TOKSUM opt_of name
	;
opt_of:
	OF
	| /* nothing */
	;
opt_report_pic:
	/* nothing */
	| PIC { 
  			curr_division = CDIV_PIC;
         }
        opt_is picture { 
            /* finish picture */
		}
	;
opt_report_column:
	COLUMN opt_number integer
	| /* nothing */
	;
report_line:
	LINE opt_number opt_line_rel integer
	;
opt_number:
	/* nothing */
	| NUMBERTOK
	;
opt_line_rel:
	/* nothing */
	| '+'
	| PLUS
	;
report_position:
	HEADING
	| FOOTING
	| /* nothing */
	;
report_type:
	PAGETOK
	| CONTROL
	| DETAIL
	;
screen_section:
    screen_section screen_item
    | /* nothing */
    ;
screen_item:
    integer opt_def_name    { 
			if ($2 == NULL) {
				$2 = alloc_filler();
				picix=piccnt=v_flag=decimals=0;
				picture[picix]=0;
			}
			define_field($1,$2); }
        screen_clauses EOS  { update_screen_field($2,$4); }
    | copy_stat             
    ;
screen_clauses:
    screen_clauses LINE 
        opt_number_is 
        opt_plus_minus
        integer     		{ scr_set_line($1,$5,$4); $$=$1; }
    | screen_clauses COLUMN 
        opt_number_is 
        opt_plus_minus
        integer     		{ scr_set_column($1,$5,$4); $$=$1; }
    | screen_clauses
		screen_attrib		{ $1->attr |= $2; $$=$1; }
	| screen_clauses FOREGROUNDCOLOR
		integer				{ $1->foreground = $3; $$=$1; }
	| screen_clauses BACKGROUNDCOLOR
		integer				{ $1->background = $3; $$=$1; }
	| screen_clauses
		screen_source_destination
	| screen_clauses
		VALUE opt_is gliteral { curr_field->value = $4; $$=$1; }
	| screen_clauses pictures
	| /* nothing */         { $$ = alloc_scr_info(); }
    ;
screen_source_destination:
	USING			{ curr_division = CDIV_PROC; } 
		name_or_lit	{
			curr_division = CDIV_DATA;
			$<sival>0->from = $<sival>0->to = $3;  
		}
	| FROM 			{ curr_division = CDIV_PROC; }
		name_or_lit
		screen_to_name	{ 
			curr_division = CDIV_DATA;
			$<sival>0->from = $3; $<sival>0->to = $4;
		}
	| req_to { curr_division = CDIV_PROC; }
		name {
			curr_division = CDIV_DATA;
			$<sival>0->from = NULL; $<sival>0->to = $3;
		}	
	;
screen_to_name:
	/* nothing */ { $$=NULL; }
	| req_to name { $$ = $2; }
	;
screen_attrib:
	BLANK SCREEN			{ $$ = SCR_BLANK_SCREEN; }
	| BLANK LINE			{ $$ = SCR_BLANK_LINE; }
	| BELL					{ $$ = SCR_BELL; }
	| sign_clause			{ $$ = $1; }
	| FULL					{ $$ = SCR_FULL; }
	| REQUIRED				{ $$ = SCR_REQUIRED; }
	| SECURE				{ $$ = SCR_SECURE; }
	| AUTO					{ $$ = SCR_AUTO; }
	| JUST RIGHT			{ $$ = SCR_JUST_RIGHT; }
	| JUST LEFT				{ $$ = SCR_JUST_LEFT; }
	| BLINK					{ $$ = SCR_BLINK; }
	| REVERSEVIDEO			{ $$ = SCR_REVERSE_VIDEO; }
	| UNDERLINE				{ $$ = SCR_UNDERLINE; }
	| LOWLIGHT				{ $$ = SCR_LOWLIGHT; }
	| HIGHLIGHT				{ $$ = SCR_HIGHLIGHT; }
	| BLANK opt_when 
		ZERONUM				{ $$ = SCR_BLANK_WHEN_ZERO; }
	;
sign_clause:
	SIGN opt_is LEADING 
		opt_separate		{ $$ = SCR_SIGN_LEADING |
								   SCR_SIGN_PRESENT | $4; }
	| SIGN opt_is TRAILING
		opt_separate		{ $$ = SCR_SIGN_PRESENT | $4; }
	;
opt_separate:
	SEPARATE opt_character	{ $$ = SCR_SIGN_SEPARATE; }
	| /* nothing */			{ $$ = 0; }
	;
opt_character:
	CHARACTER
	| /* nothing */
	;
opt_plus_minus:
    PLUS            { $$ = 1; }
    | MINUS         { $$ = -1; }
    | /* nothing */ { $$ = 0; }
    ;
opt_number_is:
	NUMBERTOK opt_is
	| /* nothing */
	;
file_section:
    file_section FD         { curr_division = CDIV_FD; } 
        STRING              { curr_division = CDIV_DATA; }
        file_attrib EOS
            {
                curr_field=NULL;
                if ($4->filenamevar == NULL) { 
                   yyerror("External file name not defined for file %s", $4->name);
                }
            }
    file_description        {   
                close_fields();
                alloc_file_entry($4);
                gen_fdesc($4,$<sval>9); 
            }
    | file_section SD { curr_division = CDIV_FD; } 
         STRING { curr_division = CDIV_DATA; }
         sort_attrib EOS
            {
                $4->organization=2;
                curr_field=NULL;
            }
    file_description    {   
                close_fields();
                alloc_file_entry($4);
                gen_fdesc($4,$<sval>9);
            }
    | copy_stat 
    | /* nothing */
    ;
file_description:
    field_description       { $<sval>$=$1; }
    | file_description field_description
    ;


field_description:   integer def_name   { define_field($1,$2); }
        redefines_clause 
        data_clauses EOS    { $$=$2; update_field(); }
    | copy_stat  { $$=NULL; }
    ;

redefines_clause:
    REDEFINES 
    { curr_division = CDIV_REDEF; } 
    def_var 
    { 
            curr_division = CDIV_DATA;
            $<sval>-1->redefines = $3;
        }
    |  /* nothing */ 
    ;
    
data_clauses:  
    /* nothing */
    | data_clauses data_clause
    ;
data_clause:
    array_options 
    | pictures 
    | usage_option
    | value_option
    | SYNC
    | JUST RIGHT {curr_field->flags.just_r=1;}
    | EXTERNAL
    ;

array_options:  OCCURS integer opt_TIMES
        { curr_field->times = $2; curr_field->occurs_flg++; }
            opt_indexed_by
     ;            

opt_key_is:  
      DIRECTION KEY CONNECTIVE STRING
     { 
       if ($3 !=IS) {
           yyerror("IS expected"); YYERROR; }
       $4->level=0;
       if ($1 == ASCENDING) {
          $4->level=-1;
       }
       if ($1 == DESCENDING) {
          $4->level=-2;
       }
       $$=$4; 
     }
     | { $$=NULL; }
     ;            

opt_indexed_by: opt_key_is INDEXED opt_by def_name
                { 
                  define_implicit_field($4, $1, curr_field->times);
                  /* Fix Me: Does not work, thus dup vars can be defined
                  if ($4->defined) {
                     yyerror("variable redefined, '%s'",$4->name);
                     $4->defined=1;
                  }
                  else { 
                     define_implicit_field($4, $1, curr_field->times);
                  } */
                } 
         | /* nothing */
         ;
              
pictures :  PIC { 
  			curr_division = CDIV_PIC;
		  	/* first pic char found */ 
          	picix=piccnt=v_flag=decimals=0;
          	picture[picix]=0;
         }
        opt_is picture { 
            /* finish picture */
            picture[picix+2]=0;
            curr_field->len=piccnt;
            curr_field->decimals=decimals;
         }
    ;

usage_option : 
    opt_USAGE opt_is usage {
            if ($3==COMP3) {
                /*curr_field->len = (piccnt/2)+1;*/
                curr_field->type='C';
            }
            else if ($3==COMP) {
                /*curr_field->len = 4;*/
                curr_field->type='B'; /* binary field */
            }
        }
    ;

value_option:  VALUE opt_is value_list
    ;
    
value_list:
	value				
	| value_list opt_comma value  
	;
value:
    gliteral    { set_variable_values($1,$1); }
    | gliteral CONNECTIVE gliteral  { 
			if ($2!=THRU)
            	yyerror("THRU expected");
    		set_variable_values($1,$3);
		}
    ;
picture: /* nothing */
    | picture pic_elem
    ;
pic_elem:
    pic_char
    | pic_char MULTIPLIER {
			int n = picture[picix+1] + $2-1;
            piccnt += $2-1;
			if (v_flag) {
				decimals += $2-1;
			}
			while (n > 255) { 
				picture[picix+1] = 255;
				picture[picix+2] = picture[picix];
				picix += 2;
				n -= 255;
			}
			picture[picix+1] = n;
        }
    ;
pic_char: CHAR {  
            if (!save_pic_char ( $1 )) {
                yyerror("invalid char in picture");
                YYERROR;
            }
        }
    ;
file_attrib:
    /* nothing */
	| file_attrib REPORT opt_is filename
	| file_attrib opt_is GLOBAL     { $<sval>0->type = 'J'; }
    | file_attrib opt_is EXTERNAL   { $<sval>0->type = 'K'; }
    | file_attrib LABEL rec_or_recs opt_is_are std_or_omitt
 /*   | file_attrib BLOCK opt_contains opt_lowbound integer chars_or_recs */
    | file_attrib BLOCK opt_contains integer chars_or_recs
    | file_attrib VALUE OF FILE_ID opt_is filename
     { 
      if ($<sval>-1->filenamevar != NULL) { 
         yyerror("Re-defining file name defined in SELECT statement"); 
      }
      else {
         $<sval>-1->filenamevar = $<sval>6; 
      }
     }
    ;
/*opt_lowbound:*/
    /* nothing */
/*    | integer CONNECTIVE    { if ($1!=TOTOK) { yyerror("TO expected"); YYERROR;} }
    ; */
sort_attrib:
    /* nothing */
    | file_attrib DIVISNUM RECORD opt_is STRING 
        { if ($2!=DATA) { yyerror("DATA expected"); YYABORT; } }
    ;
rec_or_recs:
    RECORD
    | RECORDS
    ;
std_or_omitt:
    STANDARD
    | OMITTED
    ;
opt_USAGE:
    /* nothing */
    | USAGE
    ;
opt_TIMES:
    /* nothing */
    | TIMES
    ;
opt_when:
    /* nothing */
    | WHEN  
    ;
opt_is_are:
    /* nothing */
    | CONNECTIVE    { if ($1!=IS && $1!=ARE) {
                yyerror("IS/ARE expected"); YYERROR; } }
    ;
opt_contains:
    /* nothing */
    | CONTAINS
    ;
chars_or_recs:
    CHARACTERS
    | RECORDS
    ;
opt_no:
    /* nothing */
    | CONNECTIVE    { if ($1!=NO) { yyerror("NO expected"); YYERROR;} }
    ;
usage:  USAGENUM    { $$=$1; }
    | DISPLAY   { $$=9; }
    ;
working_storage_section:
    working_storage_section
        field_description
    | /* nothing */
    ;
linkage_section:
    /* nothing */
    | linkage_section
        field_description
    ;
procedure_division:
    /* nothing */
    | procedure_division procedure_decl
    ;
procedure_decl:
    procedure_section { close_section(); open_section($1); }
    | paragraph { close_paragr(); open_paragr($1); }
    | {stabs_line();} sentence opt_EOS
    /* } statement opt_EOS */
    ;
procedure_section:
     LABELSTR SECTION EOS {
            struct sym *lab;
            lab=install($1->name,SYTB_LAB,0);
            lab->defined=1;
            $$=lab;
        }   
    ;
paragraph:
    LABELSTR dot_or_eos {
            struct sym *lab;
            if ((lab=lookup_label($1,curr_section))==NULL) {
                lab=install($1->name,SYTB_LAB,2);
                /*lab->parent=curr_section;*/
                lab->defined=1;
            }
            $$=lab;
        }
    ;
dot_or_eos:
    '.'
    | EOS
    ;
sentence:
    statement 	
    | sentence statement 
    | if_part { gen_dstlabel($1); } opt_end_if
    | if_part ELSE
      { $<dval>$=gen_passlabel(); gen_dstlabel($1); }
/*      sentence { gen_dstlabel($<dval>3); } */
      conditional_statement { gen_dstlabel($<dval>3); }
      opt_end_if 
    | SEARCH search opt_end_search
    | SEARCH ALL search_all opt_end_search
    | EVALUATE { $<ival>$ = gen_evaluate_start(); }
		selection_subject_set
		when_case_list
		END_EVALUATE { release_sel_subject($<ival>2,$3); }
    ;
selection_subject_set:
	{ $<sval>$=NULL; /* to store non-numeric symbols */ } 
	selection_subject { $$=save_sel_subject($2,NULL,(struct sym *)$1); }
	| selection_subject_set ALSO 
		{ $<sval>$=NULL; /* to store non-numeric symbols */ } 
		selection_subject 
		{ $$=save_sel_subject($4,$1,(struct sym *)$3); }
	;
selection_subject:
	expr	/* this already includes identifiers and literals */
		{ if (push_expr($1)) 
			$$=SSUBJ_EXPR; 
		  else { 
		  	$<sval>0 = $1; 
			$$=SSUBJ_STR; 
		   } 
		}
	| condition { push_condition(); $$=SSUBJ_COND; }
	| TOKTRUE	{ $$=SSUBJ_TRUE; }
	| TOKFALSE { $$=SSUBJ_FALSE; }
	;
when_case_list:
	WHEN { $<ival>$ = loc_label++; /* mark end of "when" case */ } 
		{ $<ssbjval>$=$<ssbjval>0; /* store inherited subject set */ }
		when_case 
		sentence_or_nothing
		{ $$=gen_end_when($<ival>-1,$<ival>2,$5); }
	| when_case_list WHEN { $<ival>$ = loc_label++; }
		{ $<ssbjval>$=$<ssbjval>0; }
		when_case 
		{ gen_bypass_when_case($1); }
		sentence_or_nothing
		{ $$=gen_end_when($<ival>-1,$<ival>3,$7); }
	;
when_case:
	{ $<sval>$ = NULL; }
	selection_object { 
			gen_when_check(0,$<ssbjval>0,$2,$<ival>-1,$<sval>1); 
			$$=0;
		}
	| when_case ALSO 
			{ $<sval>$ = NULL; }
			selection_object {
			gen_when_check($1+1,$<ssbjval>0,$4,$<ival>-1,$<sval>3);
			$$=$1+1;
		}
	| OTHER { $$=-1; }
	;
selection_object:
	ANY	{ $$=SOBJ_ANY; }
	| TOKTRUE { $$=SOBJ_TRUE; }
	| TOKFALSE { $$=SOBJ_FALSE; }
	| opt_not expr { 
			if (push_expr($2)) {
				if ($1) 
					$$=SOBJ_NEGEXPR;
				else 
					$$=SOBJ_EXPR; 
			}
			else { /* non-numeric comparation */
		  		$<sval>0 = $2; 
				if ($1) 
					$$=SOBJ_NEGSTR;
				else 
					$$=SOBJ_STR; 
			}
		}
	| opt_not expr CONNECTIVE expr {
			if (push_expr($4) && push_expr($2)) {
				if ($3!=THRU)
					yyerror("THRU expected");
				if ($1) 
					$$=SOBJ_NEGRANGE;
				else
					$$=SOBJ_RANGE;
			}
			else {
				yyerror("ranges only accepted for numeric variables");
			}
		}
	| opt_not cond_name { 
		gen_condition($2);
		if ($1)
			$$=SOBJ_NEGCOND;
		else
			$$=SOBJ_COND; }
	;
sentence_or_nothing:
	/* nothing */ { $$=0; }
	| sentence	  { $$=1; }
	;
if_part:
    IF  condition  { $<dval>$=gen_testif(); }
        opt_end_then 
        conditional_statement { $<dval>$=$<dval>3; }  
/*         sentence   { $<dval>$=$<dval>3; } */
    ;

/* 
  Fix me: This does not conform to the ANSI85 standard.
  However, it does reduce the number of conflicts.
*/     
conditional_statement: sentence
    |  NEXT SENTENCE 
    |  CONTINUE 
    ;

opt_not:
	/* nothing */ { $$=0; }
	| NOT { $$=1; }
	;

opt_end_if:
    | END_IF
    ;

opt_end_then:
    | THEN
    ;

search:
      variable_indexed 
      { 
        $<dval>$=loc_label++; /* determine END label name */
        gen_marklabel(); 
      } 
      search_opt_varying 
      { 
        $<dval>$=loc_label++; /* determine search loop start label */ 
        if ($3 == NULL) {
          $3=determine_table_index_name($1);
          if ($3 == NULL) {
             yyerror("Unable to determine search index for table '%s'", $1->name); 
          }
        }
        gen_jmplabel($<dval>$); /* generate GOTO search loop start  */ 
      } 
      search_opt_at_end 
      { 
        gen_jmplabel($2); /* generate GOTO END  */ 
        gen_dstlabel($4); /* generate search loop start label */
      }
      search_when  
      { 
        gen_jmplabel($2); /* generate GOTO END  */ 
        gen_dstlabel($7);

        /* increment loop index, check for end */
        gen_SearchLoopCheck($5, $3, $1);   

        gen_jmplabel($4); /* generate goto search loop start label */  
        gen_dstlabel($2); /* generate END label */ 
      }
    ;
    
search_all:
     variable_indexed
     { 
        lbend=loc_label++; /* determine END label name */
        gen_marklabel(); 

        lbstart=loc_label++; /* determine search_all loop start label */ 

        $<sval>$=determine_table_index_name($1); 
        if ($<sval>$ == NULL) {
           yyerror("Unable to determine search index for table '%s'", $1->name); 
        }
        else {
          /* Initilize and store search table index boundaries */
          Initialize_SearchAll_Boundaries($1, $<sval>$);
        }

        gen_jmplabel(lbstart); /* generate GOTO search_all loop start  */ 
     }
     search_opt_at_end 
     { 
        gen_jmplabel(lbend); /* generate GOTO END  */ 
        gen_dstlabel(lbstart); /* generate search loop start label */
     }
     search_all_when 
     { 
        gen_jmplabel(lbend); /* generate GOTO END  */ 
        gen_dstlabel($5);

        /* adjust loop index, check for end */
        gen_SearchAllLoopCheck($3, $<sval>2, $1, curr_field, lbstart, lbend);   
     }
    ;    

search_opt_varying:
    VARYING variable {  $$=$2; }
    | { $$=NULL; }
    ;

search_opt_at_end:
     opt_at END 
     { 
       $<dval>$=loc_label++; /* determine ATEND label name */
       gen_dstlabel($<dval>$); /* determine ATEND label name */
     } 
     statement 
     { 
       $<dval>$=$3;
     } 
    | 
     { 
       $<dval>$=loc_label++; /* determine ATEND label name */
       gen_dstlabel($<dval>$); /* determine ATEND label name */
     }
    ;

search_when:
     WHEN 
     search_when_conditional
     { $<dval>$=gen_testif(); } 
     search_when_statement
     { $<dval>$=$3;  } 
    ;

search_when_statement:
    search_when_statements
    |  NEXT SENTENCE 
    ;

search_when_statements:
     statement 
    | search_when_statements statement
    ;

search_when_conditional:
    name cond_op name { gen_compare($1,$2,$3); }
    | name cond_op nliteral { gen_compare($1,$2,(struct sym *)$3); }
    | nliteral cond_op name { gen_compare((struct sym *)$1,$2,$3); }
    | nliteral cond_op nliteral { 
		gen_compare((struct sym *)$1,$2,(struct sym*)$3); }
    ;

search_all_when:
     WHEN { curr_field = NULL; }
     search_all_when_conditional 
     { $<dval>$=gen_testif(); } 
     search_all_when_statement
     { $<dval>$=$4;  } 
    ;

search_all_when_statement:
    statement
    |  NEXT SENTENCE 
    ;

search_all_when_conditional:
     VARIABLE CONDITIONAL name 
        { 
          if ($2 != EQUAL) 
             yyerror("Only = conditional allowed in search all statement");
          if (curr_field == NULL) 
             curr_field = $1; 
          gen_compare($1,$2,$3); 
        }
     | VARIABLE CONDITIONAL literal 
        { 
          if ($2 != EQUAL) 
             yyerror("Only = conditional allowed in search all statement");
          if (curr_field == NULL) 
             curr_field = $1; 
          gen_compare($1,$2,(struct sym *)$3); 
        } 
    | search_all_when_conditional AND { $<dval>$=gen_andstart(); }
      search_all_when_conditional  { gen_dstlabel($<dval>3); }
    ;

opt_end_search:
    | END_SEARCH
    ;

statement:
    MOVE { }
        gname req_to        { $<ival>$=MOVE; }
        var_list
    | INITIALIZE { $<ival>$=INITIALIZE; }
        var_list
    | compute_part
        opt_end_compute
    | add_part
        opt_end_add
    | subtract_part
      opt_end_subtract
    | multiply_part
        opt_end_multiply
    | divide_part
        opt_end_divide
    | accept_part
        accept_options
    | DISPLAY { }
        disp_stat
    | open_statements
    | close_statements
    | READ 
        name opt_next
        read_into
        read_key    
        {
            if ($1==1)
		{ if ($2->organization !=2)
                   	gen_read_next($2,$4,1);
		   else
		   	gen_return($2,$4);
		}
            else if ($3>=1 && ($2->organization==1 || $2->organization==3) &&
                ($2->access_mode==2 || $2->access_mode==1))
                    gen_read_next($2,$4,$3); /* modificado para NEXT/PREV */
            else gen_read($2,$4,$5);
        }
        read_clauses
        opt_end_read
    | WRITE { }
        name write_from write_options
            {
                if ($3->level != 1)
                    yyerror("variable %s could not be used for WRITE",
                        $3->name);
                if ($1==1)
                    gen_release($3,$4);
                else
                    gen_write($3,$5,$4);
            }
        opt_end_write
    | REWRITE {  }
        name write_from
            {
                if ($3->level != 1)
                    yyerror("variable %s could not be used for REWRITE",
                        $3->name);
                gen_rewrite($3,$4);
            }
        opt_end_rewrite
    | DELETE {  }
        name opt_record { gen_delete($3); } 
        opt_end_delete
    | START name
        start_key_option 
	opt_invalid_key
	opt_end_start
    | PERFORM perform_options 
    | GO  opt_to label_list  
		opt_depending_on	{
			if ($4 == NULL) {
				gen_goto($3);
			}
			else {
				gen_goto_depending((struct list *)$3,$4);
			}
		}
    | EXIT  {  }
        opt_program     { gen_exit($3); }
    | STOP RUN          { gen_stoprun(); }
    | CALL  { curr_call_mode=CM_REF; }
        CLITERAL
        using_options       { gen_call($3,$4); }
        returning_options   { gen_store_fnres($6); }
        opt_end_call

    | SET  set_list
   	| SORT name sort_keys   { gen_sort($2); }
	 	sort_input sort_output { /*gen_close_sort($2);*/ } 
    | INSPECT 
        name 
        tallying_clause     { gen_inspect($2,(void *)$3,0); }
        replacing_clause    { gen_inspect($2,(void *)$5,1); }
    | STRINGCMD string_from_list
        INTO name string_with_pointer {
                gen_stringcmd( $2, $4, $5 );    
            }
        opt_on_overflow
        opt_end_stringcmd
    | UNSTRING name
        unstring_delimited
        INTO unstring_destinations
        string_with_pointer
        unstring_tallying {
                gen_unstring( $2, $3, $5, $6, $7 );
            }
        opt_on_overflow
        opt_end_unstring
	| INITIATE name
	| GENERATE name
	| TERMINATE name
	| copy_stat
    | READY TRACE { }
    | RESET TRACE { } 
    | error { yyerror("unknown or wrong statement"); }
        EOS
    ;

open_statements: OPEN open_statements1
    ;
open_statements1: open_mode { $<ival>$=$1; } open_varlist
    | open_statements1 open_mode { $<ival>$=$2; } open_varlist
    ;
open_varlist: name { gen_open($<ival>-1,$<sval>1); }
    |  open_varlist opt_sep name { gen_open($<ival>-1,$<sval>3); }
    ;

close_statements: CLOSE close_statements1
    ;
close_statements1: close_statement
    | close_statements1 opt_sep close_statement
    ;
close_statement: name { gen_close($1); }
    ;

compute_part: COMPUTE var_list_name
      CONDITIONAL expr
      opt_on_size_error
      { 
       struct math_var *vl1=$2;
       if ($5 != NULL) {
          gen_dstlabel($5->lbl4); /* generate bypass jump label */
       }
       if ($3!=EQUAL) {
           yyerror("= expected");
       }
       else {
          push_expr($4);
          while (vl1->next != NULL) {
            assign_expr(vl1->sname, vl1->rounded, '0'); 
            if ($5 != NULL) {
               math_on_size_error3($5);
            }
            vl1 = vl1->next;
          }
          assign_expr(vl1->sname, vl1->rounded, '1'); 
          if ($5 != NULL) {
             math_on_size_error3($5);
          }
       }
       delete_mathvar_info($2);
      }
    ;

add_part: ADD var_list_gname 
      req_to var_list_name 
      opt_on_size_error
      {
       struct math_var *vl1;
       struct math_var *vl2=$4;
       if ($5 != NULL) {
          gen_dstlabel($5->lbl4); /* generate bypass jump label */
       }
       while (vl2 != NULL) {
         push_expr(vl2->sname);
         vl1=$2;
         while (vl1 != NULL) {
            push_expr(vl1->sname);
            add_expr();
            vl1 = vl1->next;
         }
         assign_expr(vl2->sname, vl2->rounded, '1'); 
         if ($5 != NULL) {
            math_on_size_error3($5);
         }
         vl2 = vl2->next;
       }
       delete_mathvar_info($2);
       delete_mathvar_info($4);
      }
    | ADD var_list_gname req_to gname
       GIVING var_list_name 
       opt_on_size_error
      {
       struct math_var *vl1;
       struct math_var *vl2=$6;
       if ($7 != NULL) {
          gen_dstlabel($7->lbl4); /* generate bypass jump label */
       }
       vl1=$2;
       push_expr($4);
       while (vl1 != NULL) {
            push_expr(vl1->sname);
            add_expr();
            vl1 = vl1->next;
       }
       while (vl2->next != NULL) {
         assign_expr(vl2->sname, vl2->rounded, '0'); 
         if ($7 != NULL) {
            math_on_size_error3($7);
         }
         vl2 = vl2->next;
       }
       assign_expr(vl2->sname, vl2->rounded, '1'); 
       if ($7 != NULL) {
          math_on_size_error3($7);
       }
       delete_mathvar_info($2);
       delete_mathvar_info($6);
      }
    ;

subtract_part: SUBTRACT var_list_gname 
      FROM var_list_name 
      opt_on_size_error
      {
       struct math_var *vl1;
       struct math_var *vl2=$4;
       if ($5 != NULL) {
          gen_dstlabel($5->lbl4); /* generate bypass jump label */
       }
       while (vl2 != NULL) {
         push_expr(vl2->sname);
         vl1=$2;
         while (vl1 != NULL) {
            push_expr(vl1->sname);
            subtract_expr();
            vl1 = vl1->next;
         }
         assign_expr(vl2->sname, vl2->rounded, '1'); 
         if ($5 != NULL) {
            math_on_size_error3($5);
         }
         vl2 = vl2->next;
       }
       delete_mathvar_info($2);
       delete_mathvar_info($4);
      }
    | SUBTRACT var_list_gname FROM gname
      GIVING var_list_name 
      opt_on_size_error
      {
       struct math_var *vl1;
       struct math_var *vl2=$6;
       if ($7 != NULL) {
          gen_dstlabel($7->lbl4); /* generate bypass jump label */
       }
       vl1=$2;
       push_expr($4);
       while (vl1 != NULL) {
            push_expr(vl1->sname);
            subtract_expr();
            vl1 = vl1->next;
       }
       while (vl2->next != NULL) {
         assign_expr(vl2->sname, vl2->rounded, '0'); 
         if ($7 != NULL) {
            math_on_size_error3($7);
         }
         vl2 = vl2->next;
       }
       assign_expr(vl2->sname, vl2->rounded, '1'); 
       if ($7 != NULL) {
          math_on_size_error3($7);
       }
       delete_mathvar_info($2);
       delete_mathvar_info($6);
      }
    ;
    
multiply_part: MULTIPLY gname BY gname GIVING
      var_list_name 
      opt_on_size_error
      {
       struct math_var *vl1=$6;
       if ($7 != NULL) {
          gen_dstlabel($7->lbl4); /* generate bypass jump label */
       }
       push_expr($2);
       push_expr($4);
       multiply_expr();
       while (vl1->next != NULL) {
         assign_expr(vl1->sname, vl1->rounded, '0'); 
         if ($7 != NULL) {
            math_on_size_error3($7);
         }
         vl1 = vl1->next;
       }
       assign_expr(vl1->sname, vl1->rounded, '1'); 
       if ($7 != NULL) {
          math_on_size_error3($7);
       }
       delete_mathvar_info($6);
      }
    | MULTIPLY gname BY
      var_list_name 
      opt_on_size_error
      {
       struct math_var *vl1=$4;
       if ($5 != NULL) {
          gen_dstlabel($5->lbl4); /* generate bypass jump */
       }
       push_expr($2);
       while (vl1->next != NULL) {
         push_expr(vl1->sname);
         multiply_expr();
         assign_expr(vl1->sname, vl1->rounded, '0'); 
         if ($5 != NULL) {
            math_on_size_error3($5);
         }
         vl1 = vl1->next;
       }
       push_expr(vl1->sname);
       multiply_expr();
       assign_expr(vl1->sname, vl1->rounded, '1'); 
       if ($5 != NULL) {
          math_on_size_error3($5);
       }
       delete_mathvar_info($4);
      }
    ;

divide_part: DIVIDE gname BY gname GIVING 
      var_list_name 
      opt_on_size_error
      {
       struct math_var *vl1=$6;
       if ($7 != NULL) {
          gen_dstlabel($7->lbl4); /* generate bypass jump */
       }
       push_expr($2);
       push_expr($4);
       divide_expr();
       while (vl1->next != NULL) {
         assign_expr(vl1->sname, vl1->rounded, '0'); 
         if ($7 != NULL) {
            math_on_size_error3($7);
         }
         vl1 = vl1->next;
       }
       assign_expr(vl1->sname, vl1->rounded, '1'); 
       if ($7 != NULL) {
          math_on_size_error3($7);
       }
       delete_mathvar_info($6);
      }
    | DIVIDE gname BY gname GIVING name opt_rounded 
      REMAINDER name opt_on_size_error
      {
        if ($10 != NULL) {
           gen_dstlabel($10->lbl4); /* generate bypass jump */
        }
    	gen_divide($2,$4,$6,$9,$7);
        if ($10 != NULL) {
           math_on_size_error3($10);
        }
      }
    | DIVIDE gname INTO gname GIVING name opt_rounded 
      REMAINDER name opt_on_size_error
      {
        if ($10 != NULL) {
           gen_dstlabel($10->lbl4); /* generate bypass jump */
        }
    	gen_divide($4,$2,$6,$9,$7);
        if ($10 != NULL) {
           math_on_size_error3($10);
        }
      }
    | DIVIDE gname INTO gname GIVING 
      var_list_name 
      opt_on_size_error
      {
       struct math_var *vl1=$6;
       if ($7 != NULL) {
          gen_dstlabel($7->lbl4); /* generate bypass jump */
       }
       push_expr($4);
       push_expr($2);
       divide_expr();
       while (vl1->next != NULL) {
         assign_expr(vl1->sname, vl1->rounded, '0'); 
         if ($7 != NULL) {
            math_on_size_error3($7);
         }
         vl1 = vl1->next;
       }
       assign_expr(vl1->sname, vl1->rounded, '1'); 
       if ($7 != NULL) {
          math_on_size_error3($7);
       }
       delete_mathvar_info($6);
      }
    | DIVIDE gname INTO
      var_list_name 
      opt_on_size_error
      {
       struct math_var *vl1=$4;
       if ($5 != NULL) {
          gen_dstlabel($5->lbl4); /* generate bypass jump */
       }
       while (vl1 != NULL) {
         push_expr(vl1->sname);
         push_expr($2);
         divide_expr();
         assign_expr(vl1->sname, vl1->rounded, '1'); 
         if ($5 != NULL) {
            math_on_size_error3($5);
         }
         vl1 = vl1->next;
       }
       delete_mathvar_info($4);
      }
    ;

var_list_name: name opt_rounded  
     {
      $$ = create_mathvar_info(NULL, $1, $2);
     }
    | var_list_name opt_sep name opt_rounded    
     {
      $$ = create_mathvar_info($1, $3, $4);
     }
    ;
var_list_gname: gname 
     {
      $$ = create_mathvar_info(NULL, $1, 0);
     }
    | var_list_gname opt_sep gname    
     {
      $$ = create_mathvar_info($1, $3, 0);
     }
    ;

opt_rounded: { $$=0; }
    | ROUNDED { $$=1; }
    ;
opt_on_size_error: {  $$=NULL;  }
    | opt_not opt_on SIZE ERRORTOK 
     {
      $$=math_on_size_error1($1);
     }
     /* statement */
     sentence 
     { 
      math_on_size_error2();
      $<mose>$=$5;
     }
    ;

opt_end_add:
    | END_ADD  
    ;
opt_end_call:
    | END_CALL
    ;
opt_end_compute:
    | END_COMPUTE
    ;
        
opt_end_delete:
    | END_DELETE
    ;
    
opt_end_divide:
    | END_DIVIDE
    ;
opt_end_multiply:
    | END_MULTIPLY
    ;
opt_end_read:
    | END_READ
    ;
opt_end_rewrite:
    | END_REWRITE
    ;
opt_end_start:
    | END_START
    ;
opt_end_stringcmd:
    | END_STRINGCMD
    ;
opt_end_subtract:
    | END_SUBTRACT
    ;
opt_end_unstring:
    | END_UNSTRING
    ;
opt_end_write:
    | END_WRITE
    ;
opt_depending_on:
	/*nothing */ { $$=NULL; }
	| DEPENDING ONTOK subs_var { $$=$3; }
	;
label_list:
	label			{ $$ = insert_list(NULL,$1); }
	| label_list label { $$ = insert_list($1,$2); }
	;
sort_input:
    OPENMD DIVISNUM opt_is perform_range {
	 		if (($2!=PROCEDURE) || ($1!=INPUT)) {
	  			yyerror("INPUT PROCEDURE expected");
	  			YYABORT;
	   		}   
	        $$=NULL;
		}   
	| USING sort_file_list { gen_sort_using($<sval>-2,$2); $$=$2; }
	;	   
sort_output:
    OPENMD DIVISNUM opt_is perform_range {
	   		if (($2!=PROCEDURE) || ($1!=OUTPUT)) {
	     		yyerror("OUTPUT PROCEDURE expected");
		   		YYABORT;
		    }   
			$$=NULL;
		}   
	| GIVING sort_file_list { gen_sort_giving($<sval>-3,$2); $$=$2; }
	;
 sort_file_list:
  name { $$ = alloc_sortfile_node($1);  }
  | sort_file_list name { 
   		$1->next = alloc_sortfile_node($2); $$=$1;
  	}
	;
set_list: VARIABLE req_to var_or_nliteral  { 
            gen_set($1,SET_TO,$3); /*gen_move($3,$1);*/ }
    | VARIABLE UP BY var_or_nliteral   { 
            gen_set($1,SET_UP_BY,$4); /*gen_add($4,$1);*/ }
    | VARIABLE DOWN BY var_or_nliteral { 
            gen_set($1,SET_DOWN_BY,$4); /*gen_subtract($4,$1);*/ }
    /*| VARIABLE UP BY NLITERAL   
      { 
       save_literal($4,'9'); $4->all=0; gen_add((struct sym *)$4,$1); 
      }
    | VARIABLE DOWN BY NLITERAL 
      { 
       save_literal($4,'9'); $4->all=0; gen_subtract((struct sym *)$4,$1); 
      }
    | VARIABLE req_to NLITERAL  
      { 
       save_literal($3,'9'); $3->all=0; gen_move((struct sym *)$3,$1); 
      }*/
    ;

unstring_delimited:
    DELIMITED opt_by unstring_delimited_vars { $$=$3; }
    | /* nothing */                          { $$=NULL; }
    ;
unstring_delimited_vars:
    opt_all gname       { $$=alloc_unstring_delimited($1,$2); }
    | unstring_delimited_vars OR opt_all gname { 
            struct unstring_delimited *ud;
            ud=alloc_unstring_delimited($3,$4);
            ud->next = $1;
            $$=ud;
        }
    ;
unstring_destinations:
    unstring_dest_var       { $$=$1; }
    | unstring_destinations 
        unstring_dest_var   { 
            $2->next = $1;
            $$ = $2;
        }                       
    ;
unstring_dest_var:
    name opt_unstring_delim opt_unstring_count {
            $$ = alloc_unstring_dest( $1, $2, $3 );
        }
    ;
opt_unstring_delim:
    /* nothing */           { $$=NULL; }
    | DELIMITER opt_in name { $$=$3; }
    ;
opt_unstring_count:
    /* nothing */           { $$=NULL; }
    | COUNT opt_in name   { $$=$3; }
    ;
unstring_tallying:
    /* nothing */           { $$=NULL; }
    | TALLYING opt_in name  { $$=$3; }
    ;
opt_all:
    /* nothing */           { $$=0; }
    | ALL                   { $$=1; }
    ;
opt_on_overflow:
    { curr_division = CDIV_EXCEPTION; }
    on_overflow 
    on_not_overflow
    { curr_division = CDIV_PROC; }
    ;
on_overflow:
    ONTOK OVERFLOWTK          { $<dval>$ = gen_at_end(-1); }
        sentence            { gen_dstlabel($<dval>3); }
    | /* nothing */
    ;
on_not_overflow:
    NOTEXCEP ONTOK OVERFLOWTK { $<dval>$ = gen_at_end(0); }
        sentence            { gen_dstlabel($<dval>4); }
    | /* nothing */
    ;
opt_invalid_key:
    { curr_division = CDIV_EXCEPTION; }
    invalid_key 
    not_invalid_key
    { curr_division = CDIV_PROC; }
    ;
not_invalid_key:
    NOTEXCEP INVALID KEY { $<dval>$ = gen_at_end(0); }
        sentence         { gen_dstlabel($<dval>4); }
	| /* nothing */
	;
invalid_key:
	INVALID KEY        	{ $<dval>$ = gen_at_end(23); }
        sentence         { gen_dstlabel($<dval>3); }
    | /* nothing */
    ;
string_with_pointer:
    opt_with POINTER name  { $$ = $3; }
    | /* nothing */        { $$ = NULL; }
    ;
string_from_list:
    string_from             { $$ = $1; }
    | string_from_list opt_sep string_from  {
            $3->next = $1;
            $$ = $3;
        }
    | error { yyerror("variable expected"); }
    ;
string_from:
    name_or_lit   {
                $$ = alloc_string_from( $1, NULL );
            }
    | name_or_lit DELIMITED opt_by delimited_by {
                $$ = alloc_string_from( $1, $4 );
            }
    ;
delimited_by:
    name_or_lit     { $$=$1; }
    | SIZE          { $$=NULL; }
    | error { yyerror("SIZE or identifier expected"); }
    ;
copy_stat:
    COPY { curr_division = CDIV_COPYFILE;  }
    IDSTRING { include_filename = $3; } 
        copy_replace EOS 
    ;
copy_replace:
    REPLACING copy_replacements
    | /* nothing */
    | error { yyerror("COPY statement not complete"); }
    ;
copy_replacements:  
    copy_replacement
    | copy_replacements copy_replacement
    ;
copy_replacement:
    IDSTRING BY IDSTRING { add_copy_replacement($1,$3); }
    | error { yyerror("wrong replacement for COPY"); }
    ;
/**************** inspect statement **************/
tallying_clause:
    TALLYING tallying_list { $$=$2; }
    | /* nothing */        { $$=NULL; }
    ;
tallying_list:
    tallying_list
        name req_for tallying_for_list  { 
            $$ = alloc_tallying_list($1,$2,$4); }
    | /* nothing */     { $$ = NULL; }
    ;
tallying_for_list:
    tallying_for_list
        CHARACTERS inspect_before_after { 
            $$ = alloc_tallying_for_list($1,INSPECT_CHARACTERS,NULL,$3); } 
    | tallying_for_list
        ALL noallname inspect_before_after {
            $$ = alloc_tallying_for_list($1,INSPECT_ALL,$3,$4); } 
    | tallying_for_list
        LEADING noallname inspect_before_after {
            $$ = alloc_tallying_for_list($1,INSPECT_LEADING,$3,$4); } 
    | /* nothing */     { $$ = NULL; }
    ;
replacing_clause:
    REPLACING
        replacing_list      { $$ = $2; } 
    | /* nothing */         { $$ = NULL; }
    ;
replacing_list:
    replacing_list
        CHARACTERS BY noallname inspect_before_after {
            $$ = alloc_replacing_list($1,INSPECT_CHARACTERS,NULL,$4,$5); }
    | replacing_list
        replacing_kind replacing_by_list {
            $$ = alloc_replacing_list($1,$2,$3,NULL,NULL); }
    | /* nothing */     { $$ = NULL; }
    ;
replacing_by_list:
    replacing_by_list
        noallname BY noallname inspect_before_after {
            $$ = alloc_replacing_by_list($1,$2,$4,$5); }
    | /* nothing */         { $$ = NULL; }
    ;
replacing_kind:
    ALL         { $$ = INSPECT_ALL; }
    | LEADING   { $$ = INSPECT_LEADING; }
    | FIRSTTOK  { $$ = INSPECT_FIRST; }
    ;
inspect_before_after:
    inspect_before_after 
        BEFORE opt_initial noallname 
            { $$ = alloc_inspect_before_after($1,1,$4); }
    | inspect_before_after 
        AFTER opt_initial noallname  
            { $$ = alloc_inspect_before_after($1,2,$4); }
    | /* nothing */  { $$ = alloc_inspect_before_after(NULL,0,NULL); }
    ;
opt_initial:
    INITIALTOK
    | /* nothing */
    ;
req_for:
    CONNECTIVE  { if ($1!=FOR) yyerror("FOR expected"); }
    ;
/**************** sort statement ********************/
sort_keys:
    /* nothing */   { $$ = NULL; }
    | sort_keys DIRECTION KEY name
        {
            $4->direction = $2;
            (struct sym *)$4->sort_data =
                (struct sym *)($<sval>0->sort_data);
            (struct sym *)($<sval>0->sort_data) = $4;
            $$ = $4;
        }
    ;
/* the 'expr' nonterminal will have a value NULL if the parsed
   data is a valid numeric expression, otherwise will be a symbol
   reference (needed for conditionals).
   Simple variable references (incl. literals) will return
   a (struct sym *) pointer at the parser stack. */
expr:
    gname   { $$ = $1; }
    | expr '*' {push_expr($1);} 
		expr { push_expr($4); multiply_expr(); $$=NULL; }
    | expr '/' {push_expr($1);} 
		expr { push_expr($4); divide_expr(); $$=NULL; }
    | expr '+' {push_expr($1);} 
		expr { push_expr($4); add_expr(); $$=NULL; }
    | expr '-' {push_expr($1);} 
		expr { push_expr($4); subtract_expr(); $$=NULL; }
    | '(' expr ')'		{ $$=$2; }
    ;
/* opt_expr will be NULL or a (struct sym *) pointer if the expression
	was given, otherwise it will be valued -1 */
opt_expr:
	/* nothing */	{ $$ = (struct sym *)-1; }
	| expr			{ $$ = $1; }
	;
using_options:
    /* nothing */   { $$=0; }
    | USING     { $<ival>$=0; /* to save how many parameters */ }
      dummy     { $<ival>$=CALL; }
      parm_list  { $$=$<ival>2; } /* modified to signal calling pgm */
    ;
returning_options:
    /* nothing */   { $$=0; }
    | RETURNING variable { $$=$2; }
    | GIVING variable { $$=$2; }
    ;
dummy: /* nothing */ ;
using_parameters:   /* defined at procedure division */
    /* nothing */       { $$=0; }
    | USING         { $<ival>$=USING; }
        var_list    { $$=1; }
    ;
accept_part:
    ACCEPT  name  opt_line_pos { $<sval>$=$2; }
	;
accept_options:
    echo_options          { gen_accept($<sval>0,$1,1); }
    | echo_options
        ONTOK ESCAPE        { gen_accept($<sval>0,$1,1);
                      $<dval>$=gen_at_end(-1); }
        sentence        { gen_dstlabel($<dval>4); }
    | FROM DATE_TIME      { if ($2==DATE)
                    gen_accept_from_date($<sval>0);
                else if ($2==TIME)
                    gen_accept_from_time($<sval>0);
                else if ($2==INKEY)
                    gen_accept_from_inkey($<sval>0); }
    | FROM CMD_LINE      { gen_accept_from_cmdline($<sval>0); }
    | FROM ENVIRONMENT_VARIABLES  { gen_accept_env_var($<sval>0); }
    ;
echo_options:
    opt_no ECHOT    { $$=0; }
    | opt_with FILLER   { $$=2; }
    | opt_with UPDATE   { $$=8; }
    | DARK          { $$=4; }
	| /* nothing */	{ $$=1; /* default is with echo */}
	;
var_list:
    var_list opt_sep gname
        {   if ($<ival>0 == MOVE)
                gen_move($<sval>-2,$<sval>3);
            else if ($<ival>0 == INITIALIZE)
                gen_initialize($<sval>3);
            else if ($<ival>0 == ADD)
                gen_add($<sval>-2,$<sval>3,0);
            else if ($<ival>0 == USING)
                gen_save_using($<sval>3);
        }
	| gname
        {   if ($<ival>0 == MOVE)
                gen_move($<sval>-2,$<sval>1);
            else if ($<ival>0 == INITIALIZE)
                gen_initialize($<sval>1);
            else if ($<ival>0 == ADD)
                gen_add($<sval>-2,$<sval>1,0);
            else if ($<ival>0 == USING)
                gen_save_using($<sval>1);
        }
    ;
parm_list:
    parm_list opt_sep parameter
        {   if ($<ival>0 == USING)
                gen_save_using($<sval>3);
            else if ($<ival>0 == CALL) {
                gen_push_using($<sval>3);
            }
        }
	| parameter
        {   if ($<ival>0 == USING)
                gen_save_using($<sval>1);
            else if ($<ival>0 == CALL) {
                gen_push_using($<sval>1);
            }
        }
    ;
parameter:
    gname {$$=$1;$$->call_mode=curr_call_mode;}
    | BY parm_type gname
        {   $$=$3;
            curr_call_mode=$<ival>2;
            if ($$->litflag==1) {
               struct lit *lp=(struct lit *)$$;
               lp->call_mode=curr_call_mode;
               }
            else   
               $$->call_mode=curr_call_mode;
        }
 /*   | OMITTED
        {   $$=save_special_literal('0','9', "%ZEROS%");
            $$->call_mode=CM_VAL;
        } */
    ;
parm_type:
    REFERENCE {$$=CM_REF;}
    | VALUE {$$=CM_VAL;}
    | CONTENT {$$=CM_CONT;}
/*    | DESCRIPTOR {$$=CM_CONT;}*/
    ;
intrinsic_parm_list:
    intrinsic_parm_list opt_sep intrinsic_parm
        { gen_push_using($<sval>3);}
    | intrinsic_parm
        { gen_push_using($<sval>1);}
    ;
intrinsic_parm:
    gname {$$=$1;$$->call_mode=CM_REF;}
    ;
disp_stat:
    disp_var_list 
    opt_upon 
    disp_upon 
    disp_options  
	opt_line_pos { gen_display($<ival>3, $<ival>4); }
    ;
disp_var_list:
    /* nothing */
    | disp_var_list opt_sep gname { put_disp_list($3); }
    ;
disp_upon: { $<ival>$=1; }  /* default is CONSOLE (STD_OUTPUT) */
    | CONSOLE { $<ival>$=1; }
    | STD_OUTPUT { $<ival>$=1; }
    | STD_ERROR { $<ival>$=2; }
    ;

perform_range: label opt_perform_thru
      { 
	if ($2 == NULL) {
            gen_perform_thru($1,$1);
	    $$ = $1;
	}
	else  {
	    $$ = $2;
            gen_perform_thru($1,$2);
	} 
      }   
    ;

perform_options: perform_statements END_PERFORM { $$ = NULL; } 
    | gname TIMES 
      {
        gen_push_int($1);
        $<dval>$=gen_marklabel(); 
      }
      perform_statements 
      {
        gen_perform_times($<dval>3); 
      }
      END_PERFORM { $$ = NULL; }
    | opt_with_test UNTIL 
      { 
 	if ($1 == 2) {
 	   lbstart=gen_passlabel();
	}
        $<dval>$=gen_marklabel(); 
      }
      condition   
      { 
        $<dval>$=gen_orstart();
 	if ($1 == 2) {
 	   lbend=gen_passlabel();
           gen_dstlabel(lbstart);
	}
      }
      perform_statements 
      {
 	if ($1 == 2) {
           gen_jmplabel($<dval>3);
           gen_dstlabel(lbend);
           gen_jmplabel(lbstart);
           gen_dstlabel($<dval>5);
 	} 
 	else {
           gen_jmplabel($<dval>3);
           gen_dstlabel($<dval>5);
        }
      }
      END_PERFORM { $$ = NULL; }
    | opt_with_test VARYING name FROM gname opt_by gname UNTIL
      {
        gen_move($5,$3);
 	/* BEFORE=1 AFTER=2 */
 	if ($1 == 2) {
 	   lbstart=gen_passlabel();
	}
        $<dval>$=gen_marklabel();
      }
      condition 
      { 
        $<dval>$=gen_orstart();
 	/* BEFORE=1 AFTER=2 */
 	if ($1 == 2) {
           gen_add($7,$3,0);
           gen_dstlabel(lbstart);
	}
      }
      opt_perform_after 
      perform_statements 
      {
        int i;
        struct perf_info *rf;
        struct perform_info *rpi;
        char *vn;

	/* Check for duplicate varaibles in VARYING/AFTER */
 	if ($12 != NULL) {
	   if ((vn = check_perform_variables($3, $12)) != NULL) {
              yyerror("Duplicate variable '%s' in VARYING/AFTER clause", vn);        
           }
        }

 	if ($1 == 2) {
 	   if ($12 != NULL) {
 	      for (i=3; i>=0; i--) {
 	         rf = $12->pf[i];
 	         if (rf != NULL) {
                    gen_jmplabel(rf->ljmp);
                    gen_dstlabel(rf->lend);
 	         }
 	      }
 	   }
           gen_jmplabel($<dval>9);
           gen_dstlabel($<dval>11);
 	} 
 	else {
 	   if ($12 != NULL) {
 	      for (i=3; i>=0; i--) {
 	         rf = $12->pf[i];
 	         if (rf != NULL) {
                    gen_add(rf->pname1, rf->pname2, 0);
                    gen_jmplabel(rf->ljmp);
                    gen_dstlabel(rf->lend);
 	         }
 	      }
 	   }
           gen_add($7,$3,0);
           gen_jmplabel($<dval>9);
           gen_dstlabel($<dval>11);
        }
      }
      END_PERFORM { $$ = NULL; }
    | label opt_perform_thru 
      { 
        if ($2 == NULL) {
            gen_perform_thru($1,$1);
        }
        else  {
            gen_perform_thru($1,$2);
        } 
        $$ = NULL;
      } 
    | label opt_perform_thru opt_with_test UNTIL 
      { 
        $<dval>$=gen_marklabel(); 
 	/* BEFORE=1 AFTER=2 */
 	if ($3 == 2) { 
	   if ($2 == NULL) {
               gen_perform_thru($1,$1);
	   }
	   else  {
               gen_perform_thru($1,$2);
	   } 
	}
      }
      condition   
      { 
        unsigned long lbl;
        lbl=gen_orstart();
 	/* BEFORE=1 AFTER=2 */
 	if ($3 == 1) { 
	   if ($2 == NULL) {
               gen_perform_thru($1,$1);
	   }
	   else  {
               gen_perform_thru($1,$2);
	   } 
	} 
        gen_jmplabel($<dval>5);
        gen_dstlabel(lbl);
      }
    | label opt_perform_thru gname TIMES 
      {
        unsigned long lbl;	    
        gen_push_int($3);
        lbl = gen_marklabel();
	if ($2 == NULL) {
            gen_perform_thru($1,$1);
	}
	else  {
            gen_perform_thru($1,$2);
	} 
        gen_perform_times(lbl); 
      }
    | label opt_perform_thru opt_with_test VARYING name 
      FROM gname opt_by gname UNTIL
      {
        gen_move($7,$5);
        if ($3 == 2) {
 	   lbstart=gen_passlabel();
	}
        $<dval>$ = gen_marklabel();
      }
      condition 
      {
        $<dval>$ = gen_orstart();
 	/* BEFORE=1 AFTER=2 */
        if ($3 == 2) {
           gen_add($9,$5, 0);
           gen_dstlabel(lbstart);
	}
      }
      opt_perform_after 
      { 
        int i;
        struct perf_info *rf;
        struct perform_info *rpi;
        char *vn = NULL;
        
	/* Check for duplicate varaibles in VARYING/AFTER */
 	if ($14 != NULL) {
	   if ((vn = check_perform_variables($5, $14)) != NULL) {
              yyerror("Duplicate variable '%s' in VARYING/AFTER clause", vn);        
           }
        }

	if ($2 == NULL) {
            gen_perform_thru($1,$1);
	}
	else  {
            gen_perform_thru($1,$2);
	} 
 	/* BEFORE=1 AFTER=2 */
 	if ($3 == 2) {
 	   if ($14 != NULL) {
 	      for (i=3; i>=0; i--) {
 	         rf = $14->pf[i];
 	         if (rf != NULL) {
                    gen_jmplabel(rf->ljmp);
                    gen_dstlabel(rf->lend);
 	         }
 	      }
 	   }
           gen_jmplabel($<dval>11);
           gen_dstlabel($<dval>13);
 	} 
 	else {
 	   if ($14 != NULL) {
 	      for (i=3; i>=0; i--) {
 	         rf = $14->pf[i];
 	         if (rf != NULL) {
                    gen_add(rf->pname1, rf->pname2, 0);
                    gen_jmplabel(rf->ljmp);
                    gen_dstlabel(rf->lend);
 	         }
 	      }
 	   }
           gen_add($9,$5,0);
           gen_jmplabel($<dval>11);
           gen_dstlabel($<dval>13);
        }
        $$ = NULL; 
      }
    ;

opt_perform_thru: { $$ = NULL; } 
    | CONNECTIVE label 
      {
        if ($1 != THRU) 
	    yyerror("THRU expected");
	$$ = $2;
      }
    ;

opt_with_test: { $<ival>$=1; perform_after_sw=1; }
    | opt_with TEST before_after
      {
       $$=$3;
       perform_after_sw=$3; 
      }
    ;

opt_perform_after:   /* nothing */ { $$=NULL; }
    | AFTER perform_after 
     { 
      $<pfvals>$=create_perform_info(); 
      $<pfvals>$->pf[0] = $2; 
      $$=$<pfvals>$;
     }
    | AFTER perform_after AFTER perform_after 
     { 
      $<pfvals>$=create_perform_info(); 
      $<pfvals>$->pf[0] = $2; 
      $<pfvals>$->pf[1] = $4; 
      $$=$<pfvals>$;
     }
    | AFTER perform_after AFTER perform_after 
      AFTER perform_after 
     { 
      $<pfvals>$=create_perform_info(); 
      $<pfvals>$->pf[0] = $2; 
      $<pfvals>$->pf[1] = $4; 
      $<pfvals>$->pf[2] = $6; 
      $$=$<pfvals>$;
     }
    | AFTER perform_after AFTER perform_after 
      AFTER perform_after AFTER perform_after 
     { 
      $<pfvals>$=create_perform_info(); 
      $<pfvals>$->pf[0] = $2; 
      $<pfvals>$->pf[1] = $4; 
      $<pfvals>$->pf[2] = $6; 
      $<pfvals>$->pf[3] = $8; 
      $$=$<pfvals>$;
     }
    ;

perform_after: name FROM gname 
       opt_by gname UNTIL       
      {
        gen_move($3,$1);
 	/* BEFORE=1 AFTER=2 */
 	if (perform_after_sw == 2) { 
 	   lbstart=gen_passlabel();
	}
        $<dval>$ = gen_marklabel();
      }
       condition   
      { 
        unsigned long lbl;
        lbl=gen_orstart();
 	/* BEFORE=1 AFTER=2 */
 	if (perform_after_sw == 2) { 
           gen_add($5,$1,0);
           gen_dstlabel(lbstart);
           $$ = create_perf_info($5, $1, $<dval>7, lbl);
	}
	else {
           $$ = create_perf_info($5, $1, $<dval>7, lbl);
        }
      } 
    ;

perform_statements: sentence
    | CONTINUE
    ;

disp_options:
    /* nothing */           { $<ival>$=0; }
    | disp_options
       opt_with CONNECTIVE ADVANCING     
       { 
         if ($3!=NO)
            yyerror("NO expected");
         $<ival>$|=1;
       }
    | disp_options ERASE        { $<ival>$|=2; }
    ;
opt_line_pos:
	/* nothing */
	| LINE expr TOKPOSITION expr {
			screen_io_enable++; 
			push_expr($2);
			push_expr($4);
			gen_gotoxy_expr(); 
		}
	;
start_key_option:
    /* nothing */			{ gen_start($<sval>0,0,NULL); }
	| KEY opt_is cond_op name { gen_start($<sval>0,$3,$4); }
    ;
read_into:
    /* nothing */       { $$ = NULL; }
    | INTO name     { $$ = $2; }
    ;
write_from:
    /* nothing */       { $$ = NULL; }
    | FROM gname        { $$ = $2; }
    ;
write_options:
    /* nothing */                   { $$=0; }
    | before_after opt_advancing
        gname opt_line      { gen_loadvar($3); $$=$1; }
    | before_after
        opt_advancing PAGETOK  { $$=-$1; }
    ;
before_after:
    BEFORE  { $$=1; }
    | AFTER { $$=2; }
    ;
read_key:
    KEY opt_is name     { $$ = $3; }
    | /* nothing */     { $$ = NULL; }
    ;
read_clauses:
    /* nothing */
    | opt_at END            { 
                      $<dval>$=gen_at_end(10); }
        sentence        { gen_dstlabel($<dval>3); }
    | INVALID KEY           { 
                      $<dval>$=gen_at_end(23); }
        sentence        { gen_dstlabel($<dval>3); }
    ;

condition:
    expr  opt_is extended_cond_op { 
			if ($3 & COND_UNARY) {
				if ($3 & COND_CLASS) {
					gen_class_check($1,$3);
				}
				else {
					struct sym *sy=
						(struct sym *)save_special_literal('0','9', "%ZEROS%"); 
					gen_compare($1,$3&~COND_UNARY,sy);
				}
			}
				
		}
		opt_expr {
			if ($3 & COND_UNARY) {
				if ((int)$5 != -1) {
					yyerror("class or sign conditions are unary");
				}
			}
			else {
				if ((int)$5 == -1) {
					yyerror("expression expected in a binary condition");
				}
				else {
					if ($1 && $5) { 
						gen_compare($1,$3,$5);
					}
					else {
						push_expr($1);
						push_expr($5);
						gen_compare_exp($3);
						if ($5 && !$1) { /* pushed swapped? */
							gen_not();
						}
					}
				}
			}
			$$=$1; /* for implied operands */
		}
    | NOT condition     { gen_not(); $$=$2; }
    | condition AND     { $<dval>$=gen_andstart(); }
        implied_op_condition       { gen_dstlabel($<dval>3); $$=$1; }
    | condition OR      { $<dval>$=gen_orstart(); }
        implied_op_condition       { gen_dstlabel($<dval>3); $$=$1; }
    | '(' condition ')' { $$ = $2; }
    | cond_name { 
			if ($1->level != 88)
				yyerror("condition unknown");
			gen_condition($1); 
			$$=NULL;
		}
	;
implied_op_condition:
	condition		{ $$ = $1; }
	| cond_op expr  { 
					$$ = $<sval>-2;  
					if ($<sval>-2 && $2) { 
						gen_compare($<sval>-2,$1,$2);
					}
					else {
						push_expr($<sval>-2);
						push_expr($2);
						gen_compare_exp($1);
						if ($1 && !$<sval>-2) { 
							gen_not();
						}
					}
		}
	;
sign_condition:
	POSITIVE		{ $$=GREATER; }
	| NEGATIVE		{ $$=LESS; }
    | ZERONUM       { $$=EQUAL; }
	;
class_condition:
	NUMERIC				{ $$=CLASS_NUMERIC; } 
	| ALPHABETICTOK 	{ $$=CLASS_ALPHABETIC; }
	| ALPHABETICLOWER 	{ $$=CLASS_ALPHABETICLOWER; }
	| ALPHABETICUPPER 	{ $$=CLASS_ALPHABETICUPPER; }
	;	
extended_cond_op:
    ext_cond          { $$ = $1; }
    | NOT ext_cond    { $$ = $2 ^ 7; }
    | ext_cond OR ext_cond 
                        { $$ = $1 | $3; }
    ;
ext_cond:
	CONDITIONAL	opt_than_to	{ $$ = $1; }
	| class_condition		{ $$ = $1 | COND_UNARY | COND_CLASS; }
	| sign_condition		{ $$ = $1 | COND_UNARY; }
	;

cond_op:
    conditional          { $$ = $1; }
    | NOT conditional    { $$ = $2 ^ 7; }
    | conditional OR conditional 
                        { $$ = $1 | $3; }
    ;
conditional:
		CONDITIONAL	opt_than_to	{ $$ = $1; }
	;
opt_comma:
	/* nothing */
	| ','
	;
opt_sep:
    /* nothing */
    | LISTSEP
    ;
opt_EOS:
    /* nothing */
    | EOS
    ;
opt_next:
    /* nothing */ { $$=0; } 
    | NEXT      { $<ival>-1=$<ival>1; }  /* NEXT/PREV */
    ;
opt_line:
    /* nothing */
    | LINE
    ;
opt_advancing:
    /* nothing */
    | ADVANCING
    ;
opt_than_to:
    /* nothing */
    | CONNECTIVE    { if ($1!=TOTOK && $1!=THAN)
                yyerror("THAN or TO expected");
            }
    ;
opt_program:
    /* nothing */   { $$=0; }
    | PROGRAM   { $$=1; }
    ;
opt_record:
    /* nothing */
    | RECORD
    ;
opt_at: /* nothing */
    | AT
    ;
opt_in: /* nothing */
    | IN
    ;
in_of:
    IN
    | OF
    ;
opt_by: /* nothing */
    | BY 
    ;
opt_upon: /* nothing */
    | UPON 
    ;
opt_with:
    /* nothing */
    | WITH  
    ;
opt_on:
    /* nothing */
    | ONTOK  
    ;
opt_to: /* nothing */
    | CONNECTIVE    { if ($1!=TOTOK) yyerror("TO expected"); }
    ;
req_to: CONNECTIVE  { if ($1!=TOTOK) yyerror("TO required"); }
    ;
open_mode:
    OPENMD                 { $$=$1; }
    | error  { yyerror("unknown OPEN mode"); }
    ;
gname:  name    { 	
		  if (!is_variable($1)) {
				yyerror("The symbol \"%s\" is not an allowed argument here",						$1->name);
		     } 
			$$ = $1; }
    | gliteral      { $$ = (struct sym *)$1; }
    | FUNCTION LABELSTR '(' {$<ival>$=CALL;}
    		intrinsic_parm_list ')' {
    		 $$ = gen_intrinsic_call((struct sym *)$2); }
    ;
name_or_lit:
    name      { $$ = $1; }
    | literal { $$ = (struct sym *)$1; }
    ;
noallname:
    name      { $$ = $1; }
    | without_all_literal { $$ = (struct sym *)$1; }
    ;
gliteral:
    without_all_literal
    | all_literal
    ;
without_all_literal:
    literal             { $$=$1; }
    | special_literal   { $$ = $1; }
    ;
all_literal:
    ALL literal { $2->all=1; $$=$2; } 
    | ALL special_literal { $$ = $2; }
    ;
special_literal:
    SPACES          { $$=save_special_literal(' ','X', "%SPACES%"); }
    | ZERONUM       { $$=save_special_literal('0','9', "%ZEROS%"); }
    | QUOTES        { $$=save_special_literal('"','X', "%QUOTES%"); }
    | HIGHVALUES    { $$=save_special_literal('\xff','X', "%HIGH-VALUES%"); }
    | LOWVALUES     { $$=save_special_literal('\0','X', "%LOW-VALUES%"); }
    ;
var_or_nliteral:
    variable        { $$ = $1; }
    | nliteral      { $$ = (struct sym *)$1; }
    ;
nliteral:
    signed_nliteral    { save_literal($1,'9'); $1->all = 0; $$=$1; }
    ;
literal:
    signed_nliteral        { save_literal($1,'9'); $1->all=0; $$=$1; }
    | CLITERAL      { save_literal($1,'X'); $1->all=0; $$=$1; }
    ;
signed_nliteral:
	NLITERAL		{ $$=$1; }
	| '+' NLITERAL	{ $$=$2; }
	| '-' NLITERAL	{ 
			invert_literal_sign( $2 );
			$$=$2; 
		}
	;
opt_def_name:
    def_name        { $$ = $1; }
    | /* nothing */ { $$ = NULL; }
    ;
def_name:
    STRING  { if ($1->defined)
                yyerror("variable redefined, %s",$1->name);
              $1->defined=1;
              $$=$1;
            }
    | FILLER    { $<sval>$=alloc_filler(); }
    ;
def_var:
    STRING  { if (!$1->defined)
                    yyerror("variable not defined, %s",
                    $1->name);
                  /*if ($1->times>0) {
                    yyerror("%s must be indexed",$1->name);
                  }*/
                  $<sval>$=$1;
                }
    ;

variable_indexed:
    SUBSCVAR 
    { 
      if ($1->occurs_flg == 0)
         yyerror("\"%s\" is not an indexed variable ", $1->name);
      $$=$1; 
    } 
    ;

variable:
    VARIABLE {  $$=$1; } 
    | VARIABLE in_of subs_var { /* unfortunately, this must be
                                right recursive */
            $$=lookup_variable($1,$3); 
            if ($$==NULL)
                yyerror("\"%s\" is not child of \"%s\"",$1,$3);
        }
/*    | LABELSTR { yyerror("%s is not a defined variable",$1->name); } */
    ;
filename:
    literal { $$=(struct sym *)$1; }
    | STRING {$$=$1; }
    ;
cond_name:
    VARCOND '(' {  curr_division = CDIV_SUBSCRIPTS; }
        subscripts  ')' {
                  curr_division = CDIV_PROC;
                  $$ = (struct sym *)create_subscripted_var( $1, $4 ); 
                    check_subscripts($$);
            }
    | VARCOND  { $<sval>$=$1; }
    ;
name:
    subs_var '(' gname ':' gname ')' {
/*     $$ = $1; reference modifiers: not handled yet */
     $$=(struct sym *)create_refmoded_var($1, $3, $5); check_refmods((struct sym *)$$);
     }
    | subs_var 
    ;
subs_var:
    variable
    | subscripted_variable
    ;
subscripted_variable:
    SUBSCVAR '(' { curr_division = CDIV_SUBSCRIPTS; }
	subscripts ')' {
                    curr_division = CDIV_PROC;
                    $$ = (struct sym *)create_subscripted_var( $1, $4 ); 
                      check_subscripts($$);
            }
    | SUBSCVAR in_of subs_var '(' { curr_division = CDIV_SUBSCRIPTS; }
	subscripts ')' {
                    curr_division = CDIV_PROC;
                    $$ = (struct sym *)create_subscripted_var( $1, $6 ); 
                      check_subscripts($$);
            }
    ;
subscripts:
    subscript   { $$ = $1; }
    | subscripts ',' subscript { 
        $$ = add_subscript( $1, $3 ); }
    ;
subscript:
    gname                   { $$ = create_subscript( $1 ); }
    | subscript '+' gname   { $$ = add_subscript_item( $1, '+', $3 ); } 
    | subscript '-' gname   { $$ = add_subscript_item( $1, '-', $3 ); } 
    ;
integer:
    signed_nliteral    {
              char *s;
              $$=0;
              s=$1->name;
              while (isdigit(*s))
                $$ = $$ * 10 + *s++ - '0';
              if (*s)
                yyerror("only integers accepted here");
            }
    ;
label:
    LABELSTR in_of LABELSTR {
            struct sym *lab;
            if ((lab=lookup_label($1,$3))==NULL) { 
                lab = install($1->name,SYTB_LAB,2);
            }
            lab->parent = $3;
            $$ = lab;
        }
    | LABELSTR { $$=$1; }
    ;
anystring:
    STRING
    | LABELSTR
    ;
%%

/*
**  Yacc auxiliary routines
*/

/* ***********************************************
   * hterror is called where yyerror is normally *
   * called within the parser, but it also passes*
   * an error number and severity.  The error    *
   * number identifies the longer description of *
   * the error message in the compiler document- *
   * ation.  The severity is used to set the     *
   * return code that the compiler will return.  *
   ***********************************************/
void hterror(int erno, int severity, char *s,...)
{
HTG_temporary_error_code = erno;
HTG_temporary_severity = severity;

yyerror(s);

HTG_temporary_error_code = 256;
HTG_temporary_severity = 8;
return;
}


extern FILE *o_lst;

void yyerror(char *s,...)
   {
   va_list argptr;
   va_start( argptr, s);
   switch(HTG_temporary_severity)
      {
      case 0:
         {
         fprintf( stderr,"* INFO  * : %3d : line %6d, symbol %s: ",
                          HTG_temporary_error_code,lineno,yytext );
         if (HTG_list_flag) 
            {
            fprintf( o_lst,"* INFO  * %3d : line %6d, symbol %s: ",
                          HTG_temporary_error_code,lineno,yytext );
            }
         break;
         }
      case 4:
         {
         fprintf( stderr,"*WARNING* %3d : line %6d, symbol %s: ",
                          HTG_temporary_error_code,lineno,yytext );
         if (HTG_list_flag) 
            {
            fprintf( o_lst,"*WARNING* %3d : line %6d, symbol %s: ",
                          HTG_temporary_error_code,lineno,yytext );
            }
         if (HTG_RETURN_CODE < 4)
            { HTG_RETURN_CODE = 4; }
         wrncnt++;
         break;
         }
      case 8:
         {
         fprintf( stderr,"* ERROR * %3d : line %6d, symbol %s: ",
                          HTG_temporary_error_code,lineno,yytext );
         if (HTG_list_flag) 
            {
            fprintf( o_lst,"* ERROR * %3d : line %6d, symbol %s: ",
                          HTG_temporary_error_code,lineno,yytext );
            }
         if (HTG_RETURN_CODE < 8)
            { HTG_RETURN_CODE = 8; }
         errcnt++;
         break;
         }
      default:
         {
         fprintf( stderr,"*!ERROR!* %3d : line %6d, symbol %s: ",
                          HTG_temporary_error_code,lineno,yytext );
         if (HTG_list_flag) 
            {
            fprintf( o_lst,"*!ERROR!* %3d : line %6d, symbol %s: ",
                          HTG_temporary_error_code,lineno,yytext );
            }
         if (HTG_RETURN_CODE < HTG_temporary_severity)
            { HTG_RETURN_CODE = HTG_temporary_severity; }
         errcnt++;
         break;
         }
      }
   vfprintf( stderr, s, argptr );
   fprintf( stderr," ***\n");

if (HTG_list_flag) 
   {
   vfprintf( o_lst, s, argptr );
   fprintf( o_lst," ***\n");
   }
va_end( argptr );

return;
}

void yyunion( YYSTYPE *to, YYSTYPE *from ) {
    memcpy( to, from, sizeof( *from ) );
}

